VIGRA - VIGRA: TinyVector Class Template Reference

[ VIGRA Homepage | Function Index | Class Index | Namespaces | File List | Main Page ]

| TinyVector |

Class for fixed size vectors. More...

`#include <vigra/tinyvector.hxx>`

Inheritance diagram for TinyVector:

List of all members.

## Public Types
typedef BaseType::const_iterator | const_iterator
typedef BaseType::const_pointer | const_pointer
typedef BaseType::const_reference | const_reference
typedef BaseType::difference_type | difference_type
typedef BaseType::iterator | iterator
typedef BaseType::NormType | NormType
typedef BaseType::pointer | pointer
typedef BaseType::reference | reference
typedef BaseType::scalar_multiplier | scalar_multiplier
typedef BaseType::size_type | size_type
typedef BaseType::SquaredNormType | SquaredNormType
typedef BaseType::value_type | value_type
## Public Member Functions
template<class U, class DATA, class DERIVED>
TinyVector & | operator= (TinyVectorBase< U, SIZE, DATA, DERIVED > const &r)
TinyVector & | operator= (TinyVector const &r)
template<class U, class DATA, class DERIVED>
| TinyVector (TinyVectorBase< U, SIZE, DATA, DERIVED > const &r)
| TinyVector (const_pointer data)
| TinyVector (TinyVector const &r)
| TinyVector ()
| TinyVector (value_type const &i1, value_type const &i2, value_type const &i3, value_type const &i4)
| TinyVector (value_type const &i1, value_type const &i2, value_type const &i3)
| TinyVector (value_type const &i1, value_type const &i2)
| TinyVector (value_type const &initial)

## Detailed Description

### template<class T, int SIZE>
class vigra::TinyVector< T, SIZE >

Class for fixed size vectors.

This class contains an array of size SIZE of the specified VALUETYPE. The interface conforms to STL vector, except that there are no functions that change the size of a TinyVector.

Arithmetic operations on TinyVectors are defined as component-wise applications of these operations. Addition and subtraction of two TinyVectors (+=, -=, +, -, unary -), multiplication and division of an TinyVector with a double, and NumericTraits/PromoteTraits are defined, so that TinyVector fulfills the requirements of Linear Algebra.

VIGRA algorithms typically use vigra::VectorAccessor to access TinyVectors as a whole, or specific components of them.

See also:

- vigra::TinyVectorBase
- vigra::TinyVectorView
- Numeric and Promote Traits of TinyVector
- Functions for TinyVector

#include <vigra/tinyvector.hxx>
Namespace: vigra

Examples:

  palette.cxx.

## Member Typedef Documentation

typedef BaseType::const_iterator const_iterator

STL-compatible definition of const iterator

Reimplemented from TinyVectorBase.

Reimplemented in RGBValue.

typedef BaseType::const_pointer const_pointer

const pointer (return of operator-> const).

Reimplemented from TinyVectorBase.

typedef BaseType::const_reference const_reference

const reference (return of operator[] const).

Reimplemented from TinyVectorBase.

typedef BaseType::difference_type difference_type

STL-compatible definition of difference_type

Reimplemented from TinyVectorBase.

typedef BaseType::iterator iterator

STL-compatible definition of iterator

Reimplemented from TinyVectorBase.

Reimplemented in RGBValue.

typedef BaseType::NormType NormType

the vector's norm type

Reimplemented from TinyVectorBase.

Reimplemented in RGBValue.

typedef BaseType::pointer pointer

pointer (return of operator->).

Reimplemented from TinyVectorBase.

typedef BaseType::reference reference

reference (return of operator[]).

Reimplemented from TinyVectorBase.

typedef BaseType::scalar_multiplier scalar_multiplier

the scalar type for the outer product

Reimplemented from TinyVectorBase.

typedef BaseType::size_type size_type

STL-compatible definition of size_type

Reimplemented from TinyVectorBase.

typedef BaseType::SquaredNormType SquaredNormType

the vector's squared norm type

Reimplemented from TinyVectorBase.

Reimplemented in RGBValue.

typedef BaseType::value_type value_type

STL-compatible definition of valuetype

Reimplemented from TinyVectorBase.

Reimplemented in RGBValue.

## Constructor & Destructor Documentation

TinyVector | ( | value_type const & | initial | ) | `[explicit]`

Construction with constant value

TinyVector | ( | value_type const & | i1,
|  | value_type const & | i2 |
| ) |  |  |

Construction with explicit values. Call only if SIZE == 2

TinyVector | ( | value_type const & | i1,
|  | value_type const & | i2,
|  | value_type const & | i3 |
| ) |  |  |

Construction with explicit values. Call only if SIZE == 3

TinyVector | ( | value_type const & | i1,
|  | value_type const & | i2,
|  | value_type const & | i3,
|  | value_type const & | i4 |
| ) |  |  |

Construction with explicit values. Call only if SIZE == 4

TinyVector | ( |  | ) |

Default constructor (initializes all components with zero)

TinyVector | ( | TinyVector< T, SIZE > const & | r | ) |

Copy constructor.

TinyVector | ( | const_pointer | data | ) | `[explicit]`

Constructor from C array.

template<class U, class DATA, class DERIVED>
TinyVector | ( | TinyVectorBase< U, SIZE, DATA, DERIVED > const & | r | ) |

Copy with type conversion.

## Member Function Documentation

TinyVector& operator= | ( | TinyVectorBase< U, SIZE, DATA, DERIVED > const & | r | ) |

Copy assignment with type conversion.

TinyVector& operator= | ( | TinyVector< T, SIZE > const & | r | ) |

Copy assignment.

The documentation for this class was generated from the following file:

- vigra/tinyvector.hxx

© Ullrich Köthe (ullrich.koethe@iwr.uni-heidelberg.de) Heidelberg Collaboratory for Image Processing, University of Heidelberg, Germany | html generated using doxygen and Python VIGRA 1.6.0 (13 Aug 2008)